from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "Liquid Bubble Addon V2",
    "author" : "CGBlender", 
    "description" : "More free stuff for Blender: https://t.me/BlenderUniverse",
    "blender" : (3, 6, 0),
    "version" : (2, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_sna_liquid_bubble_v2_8A609(self, context):
    sna_updated_prop = self.sna_liquid_bubble_v2
    before_data = list(bpy.data.objects)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Liquid Bubble node v2.blend') + r'\Object', filename=sna_updated_prop, link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
    appended_B941D = None if not new_data else new_data[0]
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]


def sna_liquid_bubble_v2_enum_items(self, context):
    enum_items = [['Liquid Bubble s1', 'Liquid Bubble s1', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'bb1.png'))], ['Liquid Bubble ss2', 'Liquid Bubble ss2', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'bb2.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


class SNA_PT_LIQUID_BUBBLE__5ADB0(bpy.types.Panel):
    bl_label = 'Liquid Bubble '
    bl_idname = 'SNA_PT_LIQUID_BUBBLE__5ADB0'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'LB'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_liquid_bubble_v2', show_labels=False, scale=6.2900004386901855, scale_popup=8.780000686645508)
        col_2DA7F = layout.column(heading='', align=False)
        col_2DA7F.alert = False
        col_2DA7F.enabled = True
        col_2DA7F.active = True
        col_2DA7F.use_property_split = False
        col_2DA7F.use_property_decorate = False
        col_2DA7F.scale_x = 1.0
        col_2DA7F.scale_y = 1.0
        col_2DA7F.alignment = 'Expand'.upper()
        col_2DA7F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_420AE = col_2DA7F.column(heading='', align=False)
        col_420AE.alert = False
        col_420AE.enabled = True
        col_420AE.active = True
        col_420AE.use_property_split = False
        col_420AE.use_property_decorate = False
        col_420AE.scale_x = 1.0
        col_420AE.scale_y = 1.0
        col_420AE.alignment = 'Expand'.upper()
        col_420AE.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        try:
            col_420AE.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Mesh Line'].inputs[0], 'default_value', text='Bubble DSS2', icon_value=0, emboss=True)
            col_420AE.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Ico Sphere'].inputs[0], 'default_value', text='Bubble Displacement', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Ico Sphere.001'].inputs[0], 'default_value', text='Bubble Size', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Ico Sphere'].inputs[1], 'default_value', text='Subd B1', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Ico Sphere.001'].inputs[1], 'default_value', text='Subd B2', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Random Value'].inputs[2], 'default_value', text='Scale Min', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Random Value'].inputs[3], 'default_value', text='Scale Max', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Blur Attribute'].inputs[1], 'default_value', text='Bubble Blur ', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Blur Attribute'].inputs[2], 'default_value', text='Max Blur ', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Set Material'].inputs[2], 'default_value', text='Set Material', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Vector Math.001'].inputs[3], 'default_value', text='Expand', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Noise Texture'].inputs[1], 'default_value', text='W Seed', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Noise Texture'].inputs[2], 'default_value', text='W Seed 2', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Noise Texture'].inputs[3], 'default_value', text='Detail Seed ', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Clamp'].inputs[2], 'default_value', text='Rouf Seed', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Noise Texture'].inputs[5], 'default_value', text='D Seed 1', icon_value=0, emboss=True)
            col_2DA7F.prop(bpy.context.active_object.modifiers['GeometryNodes'].node_group.nodes['Noise Texture'].inputs[8], 'default_value', text='D Seed 2', icon_value=0, emboss=True)
        except:
            pass

def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_liquid_bubble_v2 = bpy.props.EnumProperty(name='Liquid Bubble v2', description='', items=sna_liquid_bubble_v2_enum_items, update=sna_update_sna_liquid_bubble_v2_8A609)
    bpy.utils.register_class(SNA_PT_LIQUID_BUBBLE__5ADB0)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_liquid_bubble_v2
    bpy.utils.unregister_class(SNA_PT_LIQUID_BUBBLE__5ADB0)
